<?php
/************************ Version 3b (20220814) ***************************/
/* Requires Version 4.0+ of HAniS: http://www.ssec.wisc.edu/hanis/index.html */
if (isset($_REQUEST['sce']) && strtolower($_REQUEST['sce']) == 'view' ) {
//--self downloader --
   $filenameReal = __FILE__;
   $download_size = filesize($filenameReal);
   header('Pragma: public');
   header('Cache-Control: private');
   header('Cache-Control: no-cache, must-revalidate');
   header("Content-type: text/plain");
   header("Accept-Ranges: bytes");
   header("Content-Length: $download_size");
   header('Connection: close');
   readfile($filenameReal);
   exit;
} ?>
<!DOCTYPE html>
<html>
<head>
  <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
  <meta http-equiv="X-UA-Compatible" content="IE=Edge"/>
  <title>GRLevel3 Animation</title>
  <script type="text/javascript" src="./HAniS/hanis_min.js"> </script>
  </head>
	<?php
	if (!isset($radar)) { // Set defaults for debugging when called alone
		$radar = 'br1'; // Default radar type is set here
		$radarLoc = 'koax'; // IMPORTAMT!!! Default radar location is set here
		$useRadarLoc = true; // Does your site include the radar location in the file name? true or false
		$imageDir = 'https://www.gwwilkins.org/grlevel3'; // Location of GRLevel3 images on server - NOTE! - now requires leading slash!
		$imageWidth = 620; // Width of radar images
		$iframeWidth = $imageWidth; // Default IFrame Width -- should no longer need adjustment
		$iframeHeight = 695; // Default IFrame Height -- adjust as needed
		$autoRefresh = true; // Use Autorefresh? true or false
		$autoRefreshTime = 8; // Number of minutes between autorefreshes.  IMPORTANT: use 2, 3, 4, 5, 6, 8, 10, 15, 20, or 30 ONLY!!!
		$autoRefreshDefaultOff = true; // Begin with Autorefresh Off? true or false
		$bgndColor = 'silver'; // Set HAniS Background Color Here
		$btnColor = 'darkslategray'; // Set Button Color here
		$btnTextColor = 'white'; // Set Button Text Color here
		############################ New in Version 2 ##########################
		$pauseSeconds = 2; // Pause on last image, in seconds
		$animRate = 20; // Frame Rate of animation: 5 is glacial, 10 is slow, 15 is leisurely, 20 is good, and 50 is fast - set with integer
		$numbImages = 10; // Number of images to display - between 3 and the number of images you are uploading
		############################ New in Version 3 ##########################
		$imageType = 'jpg'; // 'jpg' or 'png'
		$useUTC = true; // Add Seconds to time?
	}
	if (isset($_GET['radar'])) {
    $radar = $_GET['radar'];
  }
  if (isset($_GET['imageType'])) {
    $imageType = $_GET['imageType'];
  }
  if (isset($_GET['imageDir'])) {
    $imageDir = $_GET['imageDir'];
  }
  if (isset($_GET['radarLoc'])) {
    $radarLoc = $_GET['radarLoc'];
  }
  if (isset($_GET['imageWidth'])) {
    $imageWidth = $_GET['imageWidth'];
  }
  if (isset($_GET['autoRefresh'])) {
    $autoRefresh = $_GET['autoRefresh'];
  }
  if (isset($_GET['autoRefreshTime'])) {
    $autoRefreshTime = $_GET['autoRefreshTime'];
  }
  if (isset($_GET['useRadarLoc'])) {
    $useRadarLoc = $_GET['useRadarLoc'];
  }
  if (isset($_GET['bgndColor'])) {
    $bgndColor = $_GET['bgndColor'];
  }
  if (isset($_GET['autoRefreshDefaultOff'])) {
    $autoRefreshDefaultOff = $_GET['autoRefreshDefaultOff'];
  }
  if (isset($_GET['btnColor'])) {
    $btnColor = $_GET['btnColor'];
  }
  if (isset($_GET['btnTextColor'])) {
    $btnTextColor = $_GET['btnTextColor'];
  }
  if (isset($_GET['animRate'])) {
    $animRate = $_GET['animRate'];
  }
  if (isset($_GET['pauseSeconds'])) {
    $pauseSeconds = $_GET['pauseSeconds'];
  }
  if (isset($_GET['numbImages'])) {
    $numbImages = $_GET['numbImages'];
  }
?>
  <body style="width:<?php echo $imageWidth?>px; margin:0px" onload="HAniS.setup(
'filenames = <?php file_name_list($radar,$imageType,$imageDir,$radarLoc,$useRadarLoc,$numbImages)?> \n\
controls = startstop, speed, step, looprock, zoom, refresh \n\
controls_style = display:flex;flex-flow:row;background-color:<?php echo $bgndColor?>; \n\
speed_labels = Slower, Faster \n\
rate = <?php echo $animRate?> \n\
pause = <?php echo ($pauseSeconds*1000)?> \n\
skip_missing = 0 \n\
skip_missing_color = #800000 \n\
background_static = n \n\
<?php echo $autoRefresh?'auto_refresh = '.$autoRefreshTime:''?> \n\
buttons_style = flex:auto;margin:2px;background-color:<?php echo $btnColor?>;border-radius:7px;color:<?php echo $btnTextColor?>; \n\
bottom_controls = toggle, <?php echo ($autoRefresh?'autorefresh'.($autoRefreshDefaultOff?'/off':''):'')?> \n\
bottom_controls_tooltip = Toggle frames on/off AutoRefresh on/off\n\
toggle_colors = <?php echo $btnColor?>, red, orange \n\
bottom_controls_style = background-color:<?php echo $bgndColor?>;' ,
'handiv')">

  <div id="handiv" style="width:<?php echo $imageWidth?>px;background-color:#808080;">
  </div>

  </body>
 </html>
<?php
############## function ##############
function file_name_list($radar,$imageType,$imageDir,$radarLoc,$useRadarLoc,$numbImages) {
	for ($i=($numbImages-1); $i>-1; $i--) {
		$image = $imageDir.'/'.($useRadarLoc?($radarLoc.'_'):'').$radar.'_'.$i.'.'.$imageType;
		$image = getUniqueImageURL($image);
		echo $image;
		echo $i>0?', ':'';
	}
}
function getUniqueImageURL($image_url){
	$timestamp = time();
	if(strpos($image_url, '?')){
		$image_url = str_replace('?', "?$timestamp&", $image_url);
	}
	else{
		$image_url .= "?$timestamp";
	}
	return $image_url;
}
############ end function ############
?>